#!/usr/bin/perl

########################################################################
# This script does the following:
# 1. Gets the third party data tag that was set by the user
# 2. Deletes the third party data tag that was set by the user
# 3. Invokes a script called showdata.pl
########################################################################

$form_data = $ENV{'QUERY_STRING'};
@pairs=split(/&/,$form_data);
foreach $item(@pairs){
   ($key,$content)=split(/=/,$item,2);
#   $content=~tr/+/ /;
   $content=~ s/%(..)/pack("c",hex($1))/ge;
   $fields{$key}=$content;
}

$nickname = $fields{'nickname'};
$data = $fields{'data'};

$Cookies = $ENV{'HTTP_COOKIE'};

#Get tag
$GetTag = `./rsacookie -g -tag $nickname`;

$result=$? >>8;
if( $result != 0 )
{
	print("Content-Type:text/html\n\n");
	printf("<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n");
	printf("<br><font color=\"#FF0000\">Get tag $nickname failed!</font><br>");
	printf("<br><font color=\"#FF0000\">The error code is: $result </font><br>");
	printf("</BODY>\n</HTML>"); 
	exit(0);
}

#Delete tag
$DelTag = `./rsacookie -d -tag $nickname`;
$result=$? >>8;
if( $result != 0 )
{
	print("Content-Type:text/html\n\n");
	printf("<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n");
	printf("<br><font color=\"#FF0000\">Delete tag $nickname failed</font><br>");
	printf("<br><font color=\"#FF0000\">The error code is: $result </font><br>");
	printf("</BODY>\n</HTML>"); 
	exit(0);
}

#Set the Cookie to the Browser
print "Set-Cookie: $DelTag\n";

print "Content-type: text/html\n\n";
print "<html>";
print "<title>Cookie Sample</title>\n";
print "<body>";

print "<br><br>Cookies=$Cookies<p>";
print "<br><br>Get tag $nickname=$GetTag<p>";
print "<br><br>Delete tag $nicknamee=$DelTag<p>";
print "<p><a href=\"showCookie.pl?nickname=$nickname&data=$data\">show next cookie </a>";

print "</body></html>";
